# print_multiple_graphs.jl

using Plots
using Dierckx
using Polynomials
using JLD2
using JLD

gr()

p1 = plot(xlabel="Energy (a.u.)",
    ylabel="Transmission Probability",
    tickfontsize = 10,
    legend=:bottomright)

# -----------------------------------------------
# main_2d.out
k_range = [4, 5, 6, 7, 8, 8.5, 8.75, 8.85, 9, 9.5, 10, 11, 12, 13, 14, 15, 17.5, 20, 25, 30]
transm = [0.0, 0.0, 0.0, 0.0, 0.0845, 0.1155, 0.133, 0.144, 0.149, 
           0.168, 0.1995, 0.228, 0.236, 0.291, 0.3425, 
           0.3605, 0.4375, 0.5105, 0.622, 0.7255]

# transm = [0.0, 0.0965, 0.1265, 0.1475, 0.1505, 0.1285, 0.1535, 0.1795, 0.2055, 0.249,
#     0.281, 0.329, 0.3645, 0.4305, 0.487, 0.621, 0.703]
plot!(k_range, transm,
    line = (:purple),
    linewidth = 2,
    markersize = 5,
    markershape=:diamond,
    markercolor=:purple,
    markerstrokecolor = :purple,
    label="Standard FSSH")
# plot!(k_range, transm, seriestype = :scatter,label="")
# -----------------------------------------------
# -----------------------------------------------
# simple_ehrenfest.jl
# simple_ehrenfest.out
# standard_ehrenfest_erik.out
k_range = [4,5,6,7,8, 8.5, 9, 9.5, 10, 11, 12, 13, 15, 17.5, 20, 25, 30]
t = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822, 0.09529349714865712,
    0.3565087612592787, 0.37760534205097335, 0.39649317170211473, 0.41453367405344216,
    0.4320713052535279, 0.46641591370102, 0.5001672687193351, 0.5331512459661875,
    0.5951771270107584, 0.6625474770959036, 0.7178721251624632, 0.7983546667292009, 0.8507789817122509]
transm = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822,
    0.09529349714865712, 0.12763162535792738, 0.14258423467513825,
    0.1572249282841485, 0.17185391002790024, 0.18669689987372642,
    0.21754635524430616, 0.25016953112453333, 0.28425374215853066,
    0.35423797113399985, 0.4389721395465503, 0.515342845633697,
    0.637371289553109, 0.7238255806240907]
plot!(k_range, transm,
    line = (:red),
    linewidth = 2,
    markershape=:x,
    markersize = 5,
    markercolor=:red,
    markerstrokecolor=:red,
    label="Ehrenfest (CG)")
# plot!(k_range, t.^2, seriestype = :scatter, label="")



# -----------------------------------------------
# top_force.out

k_range = [4.0, 5.0, 6.0, 7.0, 8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]
transm = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822, 
          0.09529349714865712, 0.12763162535792738, 0.14258423467513825,
          0.1572249282841485, 0.17185391002790024, 0.18669689987372642,
          0.21754635524430616, 0.25016953112453333, 0.28425374215853066, 
          0.35423797113399985, 0.4389721395465503, 0.515342845633697, 
          0.637371289553109, 0.7238255806240907]

# This plot is the same algorithm as Ext Ehrenfest (CG)
# plot!(k_range, transm,
#     line = (:pink),
#     linewidth = 2,
#     markershape=:o,
#     markersize = 5,
#     markercolor=:pink,
#     markerstrokecolor=:pink,
#     label="top force")
# -----------------------------------------------
# standard_ehrenfest.out
# old modified_wrong_ehrenfest.out 

k_range = [4.0, 4.5, 5.0, 6.0, 7.0, 8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]
transm = [9.890138527238365e-10, 4.2235731279797494e-8, 2.8210424721593164e-6, 
          0.0005922637570570184, 0.01022453364264048, 0.053923685650155956, 
          0.07395949372507277, 0.09270052219932007, 0.11066546550007945, 
          0.12827793505144797, 0.16352374371528314, 0.1996386915534797, 
          0.23678003369071937, 0.31252393608949464, 0.404402244139686, 
          0.4875103511418403, 0.6201295129793427, 0.7132304400878348]
plot!(k_range, transm,
    line = (:blue),
    linewidth = 2,
    markershape=:utriangle,
    markersize = 5,
    markercolor=:blue,
    markerstrokecolor = :blue,
    label="Standard Ehrenfest")
#
# ------------------------------------------------------------------------------
# extended_ehrenfest_erik.out
k_range = [4.0, 5.0, 6.0, 7.0, 8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]

transm = [3.0690625522226084e-10, 2.4800554031108367e-6, 0.0005304055241285503, 
          0.0033952576618415673, 0.040225828460009584, 0.059251730761522625, 
          0.07752292165600702, 0.09535389705723328, 0.1130685267803067, 
          0.1490150097302425, 0.1862645607785577, 0.22477335124059614, 
          0.3033903614179563, 0.39836190021975854, 0.4836376432470471, 
          0.618568570527625, 0.7125619747802961]

plot!(k_range, transm,
    line = (:orange),
    linewidth = 2,
    markershape=:x,
    markersize = 5,
    markercolor=:orange,
    markerstrokecolor = :orange,
    label="Ext Ehrenfest")


# ------------------------------------------------------------------------------
# results from quantum dynamics
k_range= [6.0, 8.0, 4.0, 2.0, 12.0, 10.0, 14.0, 3.0]
transm= [0.010689914618721139, 0.27234796747422013, 0.015469836761815786, 0.11393869672279028, 0.9999988444526243, 0.9994214165584195, 0.9999998226153974, 0.04377425266903803]

I = sortperm(k_range)

plot!(k_range[I], transm[I],
    line = (:black),
    linewidth = 2,
    markershape=:circle,
    markersize = 5,
    markercolor=:black,
    markerstrokecolor = :black,
    label="Exact WPQD")

# ------------------------------------------------------------------------------

# ===============================================
savefig(p1, "trasmission.png")
# ------------------------------------------------------------------------------
